#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>

#define NLANCI 100000

void statistica(int sequenza[], int N, float *media, float *std);
void setRandomSeed( unsigned RandomSeed);
int dado();
int dadi(int n);

int main(int argc, char *argv[]) {
  int sequenza[NLANCI];
  int ndadi[] = {1, 2, 5, 10, 20, 50, 100};
  int i, j, n;
  float media, std;
  FILE * fp;
  char nomeFile[] = "sequenze_dadi.txt";
  
  
  setRandomSeed(1234567);

  fp = fopen(nomeFile, "w"); 
  for(i=0; i<7; i++) {
    printf("\nN dadi %d\n", ndadi[i]);
    for(j=0; j<NLANCI; j++) {
      sequenza[j] = dadi(ndadi[i]);
      // printf("%d: %d\n", j, sequenza[j] );
    }
    statistica(sequenza, NLANCI, &media, &std);
    printf(" -> media e std:  %.2f, %.2f\n", media, std);
    fprintf(fp, "%d %d %.2f %.2f\n", ndadi[i], NLANCI, media, std);
  }
  fclose(fp);
  
  return(0);
}

//----------------------------------------------------------------
void statistica(int sequenza[], int N, float *media, float *std) {
  int j;
  float s=0, s2=0;  

  // printf("[statistica] N=%d\n", N);
  for(j=0; j<N; j++) {
    // printf("%d: %d\n", j, sequenza[j] );
    s += sequenza[j];
    s2 += pow(sequenza[j], 2);
  }
  *media = s / (float) N;
  *std = sqrt( s2 / (float) N - pow(*media, 2));
  // printf("[statistica] media e std:  %.2f, %.2f\n", *media, *std);
}

//--------------------------------------------------------
int dadi(int n) {
  int i, s;
  s=0;
  for(i=0; i<n; i++) {
    s += dado();
  }
  return(s);
}

//--------------------------------------------------------
int dado() {
   return( 1 + rand() % 6 );
}

//---------------------------------------------------------
void setRandomSeed( unsigned RandomSeed) {
  
  // se RandomSeed==0  usa il tempo del computer
  // altrimenti usa il numero passato come argomento
  // Nota: RICHIEDE gli header stdlib.h e time.h
  
  time_t t;

  if (RandomSeed == 0 ) {     // se == 0 si usa il tempo
     RandomSeed = (unsigned) time(&t);
  }
  
  srand( RandomSeed );
}

